Disk ARchive: libdar::pile Class Reference

| Disk ARchive 2.8.1 Full featured and portable backup and archiving tool

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Private Member Functions | Private Attributes | List of all members
libdar::pile Class Reference
Private

stores a stack of generic_files writing/reading on each others More...

`#include <pile.hpp>`

Inherits libdar::generic_file.

## Public Member Functions
| pile ()
| the constructor
| pile (const pile &ref)=delete
| pile (pile &&ref) noexcept=delete
pile & | operator= (const pile &ref)=delete
pile & | operator= (pile &&ref) noexcept=delete
void | push (generic_file *f, const std::string &label="", bool extend_mode=false)
| add a generic_file on the top
generic_file * | pop ()
| remove the top generic_file from the top
template<class T>
bool | pop_and_close_if_type_is (T *ptr)
| remove the top generic_file and destroy it
generic_file * | top () const
| returns the address of the top generic_file
generic_file * | bottom () const
| returns the address of the bottom generic_file
U_I | size () const
| returns the number of objects in the stack
bool | is_empty () const
| returns true if the stack is empty, false otherwise.
void | clear ()
| clears the stack
template<class T>
void | find_first_from_top (T *&ref) const
| this template let the class user find out the higher object on the stack of the given type
template<class T>
void | find_first_from_bottom (T *&ref) const
| this template is similar to the template "find_first_from_top" except that the search is started from the bottom of the stack
generic_file * | get_below (const generic_file *ref)
| return the generic_file object just below the given object or nullptr if the object is at the bottom of the stack or is not in the stack
generic_file * | get_above (const generic_file *ref)
| return the generic_file object just above the given object or nullptr if the object is at the bottom of the stack or is not in the stack
generic_file * | get_by_label (const std::string &label)
| find the object associated to a given label
void | clear_label (const std::string &label)
| if label is associated to a member of the stack, makes this member of the stack an anoymous member (the label is no more associated to this object, while this object stays in the stack untouched
void | add_label (const std::string &label)
| associate a additional label to the object currently at the top of the stack
void | sync_write_above (generic_file *ptr)
| call the generic_file::sync_write() method of all object found above ptr in the stack
void | flush_read_above (generic_file *ptr)
| call the generic_file::flush_read() method of all objects found above ptr in the stack
virtual bool | skippable (skippability direction, const infinint &amount) override
| whether the implementation is able to skip
virtual bool | skip (const infinint &pos) override
| skip at the absolute position
virtual bool | skip_to_eof () override
| skip to the end of file
virtual bool | skip_relative (S_I x) override
| skip relatively to the current position
virtual bool | truncatable (const infinint &amount) const override
| whether the implementation is able to truncate to the given position
virtual infinint | get_position () const override
| get the current read/write position
void | copy_to (generic_file &ref) override
| copy all data from current position to the object in argument
void | copy_to (generic_file &ref, const infinint &crc_size, crc *&value) override
| copy all data from the current position to the object in argument and computes a CRC value of the transmitted data
Public Member Functions inherited from libdar::generic_file
| generic_file (gf_mode m)
| main constructor
| generic_file (const generic_file &ref)
| copy constructor
| generic_file (generic_file &&ref) noexcept
| move constructor
generic_file & | operator= (const generic_file &ref)
| assignment operator
generic_file & | operator= (generic_file &&ref) noexcept
| move operator
| ~generic_file () noexcept(false)
| virtual destructor,
void | terminate ()
| destructor-like call, except that it is allowed to throw exceptions
bool | operator== (generic_file &ref)
bool | operator!= (generic_file &ref)
gf_mode | get_mode () const
| retreive the openning mode for this object
void | read_ahead (const infinint &amount)
void | ignore_read_ahead (bool mode)
virtual U_I | read (char *a, U_I size) override
| read data from the generic_file inherited from proto_generic_file
virtual void | write (const char *a, U_I size) override
| write data to the generic_file inherited from proto_generic_file
void | write (const std::string &arg)
| write a string to the generic_file
S_I | read_back (char &a)
| skip back one char, read on char and skip back one char
S_I | read_forward (char &a)
| read one char
virtual void | truncate (const infinint &pos)
| truncate file at the given offset
U_32 | copy_to (generic_file &ref, U_32 size)
| small copy (up to 4GB) with CRC calculation
infinint | copy_to (generic_file &ref, infinint size)
| copy the given amount to the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value)
| compares the contents with the object in argument
bool | diff (generic_file &f, const infinint &me_read_ahead, const infinint &you_read_ahead, const infinint &crc_size, crc *&value, infinint &err_offset)
void | reset_crc (const infinint &width)
| reset CRC on read or writen data
bool | crc_status () const
| to known whether CRC calculation is activated or not
crc * | get_crc ()
| get CRC of the transfered date since last reset
void | sync_write ()
| write any pending data
void | flush_read ()
| be ready to read at current position, reseting all pending data for reading, cached and in compression engine for example
Public Member Functions inherited from libdar::proto_generic_file
| proto_generic_file (const proto_generic_file &ref)=default
| copy constructor
| proto_generic_file (proto_generic_file &&ref) noexcept=default
| move constructor
proto_generic_file & | operator= (const proto_generic_file &ref)=default
| assignment operator
proto_generic_file & | operator= (proto_generic_file &&ref) noexcept=default
| move operator
virtual | ~proto_generic_file () noexcept(false)
| virtual destructor

## Protected Member Functions
virtual void | inherited_read_ahead (const infinint &amount) override
| tells the object that several calls to read() will follow to probably obtain at least the given amount of data
virtual U_I | inherited_read (char *a, U_I size) override
| implementation of read() operation
virtual void | inherited_write (const char *a, U_I size) override
| implementation of the write() operation
virtual void | inherited_truncate (const infinint &pos) override
| truncate file at the give offset
virtual void | inherited_sync_write () override
| write down any pending data
virtual void | inherited_flush_read () override
| reset internal engine, flush caches in order to read the data at current position
virtual void | inherited_terminate () override
| destructor-like call, except that it is allowed to throw exceptions
Protected Member Functions inherited from libdar::generic_file
void | set_mode (gf_mode x)
bool | is_terminated () const

## Private Member Functions
void | detruit ()
std::deque< face >::iterator | look_for_label (const std::string &label)

## Private Attributes
std::deque< face > | stack

## Additional Inherited Members
Public Types inherited from libdar::generic_file
enum | skippability { skip_backward , skip_forward }

## Detailed Description

stores a stack of generic_files writing/reading on each others

Definition at line 43 of file pile.hpp.

## Constructor & Destructor Documentation

## ◆ pile()

libdar::pile::pile | ( |  | ) |
| inline

the constructor

Note
  the mode (gf_mode) of the pile is the one of the first object pushed on the stack, thus when empty we choose the arbitrary gf_read_only value, because the stack is empty.

Definition at line 51 of file pile.hpp.

References libdar::generic_file::generic_file(), and libdar::gf_read_only.

## ◆ ~pile()

libdar::pile::~pile | ( |  | ) |
| inline

Definition at line 56 of file pile.hpp.

## Member Function Documentation

## ◆ add_label()

void libdar::pile::add_label | ( | const std::string & | label | ) |

associate a additional label to the object currently at the top of the stack

Parameters

  [in] | label | the label to add

Note
  this does not remove an eventually existing label that had been added either by push() or add_label() previously
  an object of the stack can thus be refered by several different labels

## ◆ bottom()

generic_file * libdar::pile::bottom | ( |  | ) | const
| inline

returns the address of the bottom generic_file

Definition at line 87 of file pile.hpp.

References libdar::generic_file::generic_file().

## ◆ clear()

void libdar::pile::clear | ( |  | ) |
| inline

clears the stack

Definition at line 96 of file pile.hpp.

## ◆ clear_label()

void libdar::pile::clear_label | ( | const std::string & | label | ) |

if label is associated to a member of the stack, makes this member of the stack an anoymous member (the label is no more associated to this object, while this object stays in the stack untouched

Parameters

  [in] | label | the label to clear, empty string is not a valid label an exception is thrown if used here

Note
  no exception is thrown else, even if the label is not present in the stack

## ◆ copy_to() [1/2]

void libdar::pile::copy_to | ( | generic_file & | ref | ) |
| overridevirtual

copy all data from current position to the object in argument

Reimplemented from libdar::generic_file.

References libdar::generic_file::generic_file().

## ◆ copy_to() [2/2]

void libdar::pile::copy_to | ( | generic_file & | ref,
|  | const infinint & | crc_size,
|  | crc *& | value )
| overridevirtual

copy all data from the current position to the object in argument and computes a CRC value of the transmitted data

Parameters

  [in] | ref | defines where to copy the data to
  [in] | crc_size | tell the width of the crc to compute on the copied data
  [out] | value | points to a newly allocated crc object containing the crc value

Note
  value has to be deleted by the caller when no more needed

Reimplemented from libdar::generic_file.

References libdar::generic_file::generic_file().

## ◆ get_by_label()

generic_file * libdar::pile::get_by_label | ( | const std::string & | label | ) |

find the object associated to a given label

Parameters

  [in] | label | is the label to look for, empty string is forbidden

Returns
  the object associated to label, else an exception is thrown

References libdar::generic_file::generic_file().

## ◆ get_position()

virtual infinint libdar::pile::get_position | ( |  | ) | const
| overridevirtual

get the current read/write position

Implements libdar::generic_file.

## ◆ inherited_flush_read()

virtual void libdar::pile::inherited_flush_read | ( |  | ) |
| overrideprotectedvirtual

reset internal engine, flush caches in order to read the data at current position

Note
  when the object relies on external object or system object to fetch the data from for reading, when a call to (inherited_)flush_read() occurs, the current object must not assume that any previously read data is still valid if it has internal buffers or the like and it should flush them asap. This call must not propagate the flush_read to any other gneric_file object it could rely on

Implements libdar::generic_file.

## ◆ inherited_read()

virtual U_I libdar::pile::inherited_read | ( | char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of read() operation

Parameters

  [in,out] | a | where to put the data to read
  [in] | size | says how much data to read

Returns
  the exact amount of data read and put into 'a'

Note
  read as much byte as requested, up to end of file stays blocked if not enough data is available and EOF not yet met. May return less data than requested only if EOF as been reached. in other worlds, EOF is reached when returned data is stricly less than the requested data Any problem shall be reported by throwing an exception.

Implements libdar::generic_file.

References size().

## ◆ inherited_read_ahead()

virtual void libdar::pile::inherited_read_ahead | ( | const infinint & | amount | ) |
| overrideprotectedvirtual

tells the object that several calls to read() will follow to probably obtain at least the given amount of data

Parameters

  [in] | amount | is the maximum expected amount of data that is known to be read

Note
  this call may be implemented as a do-nothing call, its presence is only to allow optimization when possible, like in multi-threaded environment

Implements libdar::generic_file.

## ◆ inherited_sync_write()

virtual void libdar::pile::inherited_sync_write | ( |  | ) |
| overrideprotectedvirtual

write down any pending data

Note
  called after sanity checks from generic_file::sync_write() this method's role is to write down any data pending for writing in the current object it has not to be propagated to other gneric_file object this object could rely on

Implements libdar::generic_file.

## ◆ inherited_terminate()

virtual void libdar::pile::inherited_terminate | ( |  | ) |
| overrideprotectedvirtual

destructor-like call, except that it is allowed to throw exceptions

Note
  this method must never be called directly but using terminate() instead, generic_file class manages it to never be called more than once

Implements libdar::generic_file.

References libdar::generic_file::generic_file().

## ◆ inherited_truncate()

virtual void libdar::pile::inherited_truncate | ( | const infinint & | pos | ) |
| overrideprotectedvirtual

truncate file at the give offset

Note
  if pos is greater than the current file size, this call may do nothing (not even enlarging the file)
  this call should always fail on a read-only generic_file
  implementation must throw exception if truncate is not possible for other reason than read/write access mode

Implements libdar::generic_file.

## ◆ inherited_write()

virtual void libdar::pile::inherited_write | ( | const char * | a,
|  | U_I | size )
| overrideprotectedvirtual

implementation of the write() operation

Parameters

  [in] | a | what data to write
  [in] | size | amount of data to write

Note
  must either write all data or report an error by throwing an exception

Implements libdar::generic_file.

References size().

## ◆ is_empty()

bool libdar::pile::is_empty | ( |  | ) | const
| inline

returns true if the stack is empty, false otherwise.

Definition at line 93 of file pile.hpp.

## ◆ pop()

generic_file * libdar::pile::pop | ( |  | ) |

remove the top generic_file from the top

Returns
  the address of the object that has been poped from the stack or nullptr if the stack is empty

Note
  this is now the duty of the caller to release this object memory when the object is no more needed

References libdar::generic_file::generic_file().

## ◆ push()

void libdar::pile::push | ( | generic_file * | f,
|  | const std::string & | label = "",
|  | bool | extend_mode = false )

add a generic_file on the top

Parameters

  [in] | f | is the address of the object to add to the stack
  [in] | label | unique label associated to this object in the current stack, exception thrown if label already used in stack
  [in] | extend_mode | allow the new object to have more read/write permission than the already placed object, which have the effect to change the read/write permission of the stack itself, future push() will accept wider permission even if extend_mode is not set

Note
  once added, the object memory allocation is managed by the pile object the pile is responsible of destroying this object if its destructor is called however, the pile object releases its responsibility about any object that will be poped (see pop() below) from the stack.
  empty label (empty string) is the only identical value that can be used for several objects of the stack

References libdar::generic_file::generic_file().

## ◆ size()

U_I libdar::pile::size | ( |  | ) | const
| inline

returns the number of objects in the stack

Definition at line 90 of file pile.hpp.

Referenced by inherited_read(), and inherited_write().

## ◆ skip()

virtual bool libdar::pile::skip | ( | const infinint & | pos | ) |
| overridevirtual

skip at the absolute position

Parameters

  [in] | pos | the offset in byte where next read/write operation must start

Returns
  true if operation was successfull and false if the requested position is not valid (after end of file)

Note
  if requested position is not valid the reading/writing cursor must be set to the closest valid position

Implements libdar::generic_file.

## ◆ skip_relative()

virtual bool libdar::pile::skip_relative | ( | S_I | x | ) |
| overridevirtual

skip relatively to the current position

Implements libdar::generic_file.

## ◆ skip_to_eof()

virtual bool libdar::pile::skip_to_eof | ( |  | ) |
| overridevirtual

skip to the end of file

Implements libdar::generic_file.

## ◆ skippable()

virtual bool libdar::pile::skippable | ( | skippability | direction,
|  | const infinint & | amount )
| overridevirtual

whether the implementation is able to skip

Note
  the capability to skip does not mean that skip_relative() or skip() will succeed, but rather that the inherited class implementation does not by construction forbid the requested skip (like inherited class providing a generic_file interface of an anonymous pipe for example)

Implements libdar::generic_file.

## ◆ top()

generic_file * libdar::pile::top | ( |  | ) | const
| inline

returns the address of the top generic_file

Definition at line 84 of file pile.hpp.

References libdar::generic_file::generic_file().

Referenced by pop_and_close_if_type_is().

## ◆ truncatable()

virtual bool libdar::pile::truncatable | ( | const infinint & | pos | ) | const
| overridevirtual

whether the implementation is able to truncate to the given position

Implements libdar::generic_file.

## Member Data Documentation

## ◆ stack

std::deque<face> libdar::pile::stack
| private

Definition at line 175 of file pile.hpp.

The documentation for this class was generated from the following file:

- pile.hpp